# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

parser_class = "bn2_serhost"


def test_encode_order(self):
    message = self.order()
    expected = (
        "J123456 NYME                     1F1   A B 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0"
    )
    assert message == expected


def test_decode_result(self):
    worklist = self.decode(
        "D62120078126 MET                27   10      1.5300E+01 mg/l     "
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "type": "patient",
                "sample_id": "62120078126",
                "last_name": "MET",
                "results": [
                    {
                        "code": "27",
                        "value": "1.5300E+01",
                        "flags": ["BELLOW_RANGE", "SPECIAL_PREDILUTION"],
                    }
                ],
            }
        ],
    }
    assert worklist == expected


def test_decode_control(self):
    worklist = self.decode("R0839  1    0      1.2700E+01 g/l            2.0000E-00 ")
    worklist.samples[0].results[0].date = worklist.samples[0].results[0].date.date()
    expected = {
        "context": "result",
        "samples": [
            {
                "type": "control",
                "control_lot": "0839",
                "sample_id": "0839",
                "results": [
                    {
                        "code": "1",
                        "value": "1.2700E+01",
                        "flags": [],
                        "date": datetime.date.today(),
                    }
                ],
            }
        ],
    }
    assert worklist == expected
