# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

parser_class = "exicycler"


def test_decode_result(self):
    date_last_analysis = datetime.datetime(2020, 9, 24, 18, 51, 56)
    worklist = self.decode(
        """
    Exicycler Data Name: 2020_9_21_23_33_16_663
    Assay Type: Absolute Quantification
    User: Guest
    Instrument S/N : EXI96V4-05N-BXC018

    Run Date : ,Sep 22 2020 01:31:43
    Last Analysis: ,Sep 24 2020 18:51:56

    Protocol information
    Step,Function,Temperature,Time (hh:mm:ss),Repeat
    1,INCUBATE,45.00, 0:15:0,0
    2,INCUBATE,95.00, 0:2:0,0
    3,INCUBATE,95.00, 0:0:10,0
    4,INCUBATE,60.00, 0:0:50,0
    5,SCAN,,,0
    6,GOTO,Step3, ,45
    7,INCUBATE,20.00, 0:1:0,0
    8,End

    Data
    Well,Sample Name,Probe Name,Type,Flu. Dye,Quencher,Ct,Concentration ,Ct Threshold, Start Baseline, End Baseline,Tm
    A1,essai,Std_FAM,Sample,FAM,BHQ,-1,0.00E+00,3537,Auto,Auto
    A1,essai,Std_JOE,Sample,JOE,BHQ,21.81,0.00E+00,3220,Auto,Auto
    A1,essai,Std_ROX,Sample,ROX,BHQ,-1,0.00E+00,5465,Auto,Auto
    B1,123456,Std_FAM,Sample,FAM,BHQ,-1,0.00E+00,3537,Auto,Auto
    B1,123456,Std_JOE,Sample,JOE,BHQ,21.56,0.00E+00,3220,Auto,Auto
    B1,123456,Std_ROX,Sample,ROX,BHQ,-1,0.00E+00,5465,Auto,Auto
    C1,7890,Std_FAM,Sample,FAM,BHQ,-1,0.00E+00,3537,Auto,Auto
    C1,7890,Std_JOE,Sample,JOE,BHQ,21.39,0.00E+00,3220,Auto,Auto
    C1,7890,Std_ROX,Sample,ROX,BHQ,-1,0.00E+00,5465,Auto,Auto
    """
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "rack": "A1",
                "sample_id": "essai",
                "type": "patient",
                "results": [
                    {"code": "RUN_DATE", "value": "22/09/2020 01:31:43"},
                    {"code": "POSITION", "value": "A1"},
                    {
                        "code": "CtStd_FAM",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "-1",
                    },
                    {
                        "code": "ConcentrationStd_FAM",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "0.00E+00",
                    },
                    {
                        "code": "Ct ThresholdStd_FAM",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "3537",
                    },
                    {
                        "code": "CtStd_JOE",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "21.81",
                    },
                    {
                        "code": "ConcentrationStd_JOE",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "0.00E+00",
                    },
                    {
                        "code": "Ct ThresholdStd_JOE",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "3220",
                    },
                    {
                        "code": "CtStd_ROX",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "-1",
                    },
                    {
                        "code": "ConcentrationStd_ROX",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "0.00E+00",
                    },
                    {
                        "code": "Ct ThresholdStd_ROX",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "5465",
                    },
                ],
            },
            {
                "rack": "B1",
                "sample_id": "123456",
                "type": "patient",
                "results": [
                    {"code": "RUN_DATE", "value": "22/09/2020 01:31:43"},
                    {"code": "POSITION", "value": "B1"},
                    {
                        "code": "CtStd_FAM",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "-1",
                    },
                    {
                        "code": "ConcentrationStd_FAM",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "0.00E+00",
                    },
                    {
                        "code": "Ct ThresholdStd_FAM",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "3537",
                    },
                    {
                        "code": "CtStd_JOE",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "21.56",
                    },
                    {
                        "code": "ConcentrationStd_JOE",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "0.00E+00",
                    },
                    {
                        "code": "Ct ThresholdStd_JOE",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "3220",
                    },
                    {
                        "code": "CtStd_ROX",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "-1",
                    },
                    {
                        "code": "ConcentrationStd_ROX",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "0.00E+00",
                    },
                    {
                        "code": "Ct ThresholdStd_ROX",
                        "date": date_last_analysis,
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "5465",
                    },
                ],
            },
            {
                "rack": "C1",
                "sample_id": "7890",
                "type": "patient",
                "results": [
                    {"code": "RUN_DATE", "value": "22/09/2020 01:31:43"},
                    {"code": "POSITION", "value": "C1"},
                    {
                        "code": "CtStd_FAM",
                        "date": datetime.datetime(2020, 9, 24, 18, 51, 56),
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "-1",
                    },
                    {
                        "code": "ConcentrationStd_FAM",
                        "date": datetime.datetime(2020, 9, 24, 18, 51, 56),
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "0.00E+00",
                    },
                    {
                        "code": "Ct ThresholdStd_FAM",
                        "date": datetime.datetime(2020, 9, 24, 18, 51, 56),
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "3537",
                    },
                    {
                        "code": "CtStd_JOE",
                        "date": datetime.datetime(2020, 9, 24, 18, 51, 56),
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "21.39",
                    },
                    {
                        "code": "ConcentrationStd_JOE",
                        "date": datetime.datetime(2020, 9, 24, 18, 51, 56),
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "0.00E+00",
                    },
                    {
                        "code": "Ct ThresholdStd_JOE",
                        "date": datetime.datetime(2020, 9, 24, 18, 51, 56),
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "3220",
                    },
                    {
                        "code": "CtStd_ROX",
                        "date": datetime.datetime(2020, 9, 24, 18, 51, 56),
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "-1",
                    },
                    {
                        "code": "ConcentrationStd_ROX",
                        "date": datetime.datetime(2020, 9, 24, 18, 51, 56),
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "0.00E+00",
                    },
                    {
                        "code": "Ct ThresholdStd_ROX",
                        "date": datetime.datetime(2020, 9, 24, 18, 51, 56),
                        "instrument": "EXI96V4-05N-BXC018",
                        "value": "5465",
                    },
                ],
            },
        ],
    }
    assert worklist == expected
