# -*- coding: utf8 -*-
from __future__ import unicode_literals

import datetime

from driverng.tests import BaseTest


class TestHa81(BaseTest):
    MAPPING_CLASS = "ha81"

    def test_result(self):
        date = datetime.datetime(2013, 8, 28, 17, 1)
        self.assertResultEqual(
            """NO.0047 BC.02807505----- 13-08-28\r\n17:01 HbA1c06.3 HbA107.5 HbF01.5  \r\n""",
            {
                "02807505": {
                    "resultats": [
                        {"test": "HbA1c", "date": date, "resu": "06.3"},
                        {"test": "HbA1", "date": date, "resu": "07.5"},
                        {"test": "HbF", "date": date, "resu": "01.5"},
                    ]
                }
            },
        )

    @staticmethod
    def unindent(data):
        return data
