# -*- coding: utf8 -*-
from __future__ import unicode_literals

parser_class = "kpcr_ad"


def test_decode_result(self):
    worklist = self.decode(
        """
    @Header
    Software=VERSANT kPCR AD  v 2.0
    InstrumentID=DE31700351
    Operator=BayerAdmin
    Run=20160126CMVEBVHHV6ADV_26 Jan 2016 17_34_58 25 Mar 2016 10:56:51
    Test Definition Version=1.0
    Database=Stratagene
    RunDate=January 26, 2016
    PlateMap=\\versantkpcr-sp\\platemaps\\0000195474.map
    ImportDate=26/01/2016 14:39:09
    Protocol=CMV-EBV-HHV6-ADV
    PrimaryUnits=IU/mL
    @Kit
    Name1=Sample Preparation Reagents
    Number1=G015X
    Expiration1=2017-05-25
    @TestResults
    Well|Sample ID|Channel|Well Type|Quantity|Notes|Ct|Well Comment
    A1|CMV-A1|Ref|Calibrator|Reference||Reference|---
    A1|CMV-A1|CMV|Calibrator|5.05e+006||23.90|---
    A2|91604019449802|Ref|Unknown|Reference||Reference|---
    A2|91604019449802|IC|Unknown|<2 Unique IC Calibrators with Reference||26.50|---
    A2|91604019449802|CMV|Unknown|No Ct||No Ct|---
    A4|EBV-A4|Ref|Calibrator|Reference||Reference|---
    A4|EBV-A4|EBV|Calibrator|5.05e+006||23.73|---
    A5|91604019449802|Ref|Unknown|Reference||Reference|---
    A5|91604019449802|IC|Unknown|<2 Unique IC Calibrators with Reference||27.95|---
    A5|91604019449802|EBV|Unknown|No Ct||No Ct|---
    A7|HHV6-A7|Ref|Calibrator|Reference||Reference|---
    A7|HHV6-A7|HHV6|Calibrator|5.05e+006||21.92|---
    A8|91604019449802|Ref|Unknown|Reference||Reference|---
    A8|91604019449802|IC|Unknown|<2 Unique IC Calibrators with Reference||27.29|---
    A8|91604019449802|HHV6|Unknown|No Ct||No Ct|---
    A10|ADV-A10|Ref|Calibrator|Reference||Reference|---
    A10|ADV-A10|ADV|Calibrator|5.05e+006||23.33|---
    A11|91604019449802|Ref|Unknown|Reference||Reference|---
    A11|91604019449802|IC|Unknown|<2 Unique IC Calibrators with Reference||27.45|---
    A11|91604019449802|ADV|Unknown|No Ct||No Ct|---
    B1|CMV-B1|Ref|Calibrator|Reference||Reference|---
    B1|CMV-B1|CMV|Calibrator|5.05e+005||27.47|---
    B2|91604019459802|Ref|Unknown|Reference||Reference|---
    B2|91604019459802|IC|Unknown|<2 Unique IC Calibrators with Reference||27.19|---
    B2|91604019459802|CMV|Unknown|No Ct||No Ct|---
    B4|EBV-B4|Ref|Calibrator|Reference||Reference|---
    B4|EBV-B4|EBV|Calibrator|5.05e+005||26.92|---
    B5|91604019459802|Ref|Unknown|Reference||Reference|---
    B5|91604019459802|IC|Unknown|<2 Unique IC Calibrators with Reference||28.59|---
    B5|91604019459802|EBV|Unknown|No Ct||No Ct|---
    @EndReport
    """
    )
    expected = {
        "context": "result",
        "samples": [
            {
                "control_lot": "Sample ID-Channel",
                "results": [
                    {"code": "Channel", "value": "Quantity"},
                    {"code": "Channelct", "value": "Ct"},
                ],
                "sample_id": "Sample ID-Channel",
                "type": "control",
            },
            {
                "results": [
                    {"code": "Ref", "value": "Reference"},
                    {"code": "Refct", "value": "Reference"},
                    {"code": "IC", "value": "<2 Unique IC Calibrators with Reference"},
                    {"code": "ICct", "value": "26.50"},
                    {"code": "CMV", "value": "No Ct"},
                    {"code": "CMVct", "value": "No Ct"},
                    {"code": "Ref", "value": "Reference"},
                    {"code": "Refct", "value": "Reference"},
                    {"code": "IC", "value": "<2 Unique IC Calibrators with Reference"},
                    {"code": "ICct", "value": "27.95"},
                    {"code": "EBV", "value": "No Ct"},
                    {"code": "EBVct", "value": "No Ct"},
                    {"code": "Ref", "value": "Reference"},
                    {"code": "Refct", "value": "Reference"},
                    {"code": "IC", "value": "<2 Unique IC Calibrators with Reference"},
                    {"code": "ICct", "value": "27.29"},
                    {"code": "HHV6", "value": "No Ct"},
                    {"code": "HHV6ct", "value": "No Ct"},
                    {"code": "Ref", "value": "Reference"},
                    {"code": "Refct", "value": "Reference"},
                    {"code": "IC", "value": "<2 Unique IC Calibrators with Reference"},
                    {"code": "ICct", "value": "27.45"},
                    {"code": "ADV", "value": "No Ct"},
                    {"code": "ADVct", "value": "No Ct"},
                ],
                "sample_id": "91604019449802",
                "type": "patient",
            },
            {
                "results": [
                    {"code": "Ref", "value": "Reference"},
                    {"code": "Refct", "value": "Reference"},
                    {"code": "IC", "value": "<2 Unique IC Calibrators with Reference"},
                    {"code": "ICct", "value": "27.19"},
                    {"code": "CMV", "value": "No Ct"},
                    {"code": "CMVct", "value": "No Ct"},
                    {"code": "Ref", "value": "Reference"},
                    {"code": "Refct", "value": "Reference"},
                    {"code": "IC", "value": "<2 Unique IC Calibrators with Reference"},
                    {"code": "ICct", "value": "28.59"},
                    {"code": "EBV", "value": "No Ct"},
                    {"code": "EBVct", "value": "No Ct"},
                ],
                "sample_id": "91604019459802",
                "type": "patient",
            },
        ],
    }
    assert worklist == expected
