# -*- coding: utf-8 -*-

from __future__ import unicode_literals

from driverng.tests import BaseTest


class SQAVisionTest(BaseTest):
    PROTOCOL_CLASS = "sqavision"

    def test_recv_message(self):
        self.assertRecvMessageEqual(
            """
            recv <stx>2O|SN#^52^|SID^6^|FIC^5^|ATM^08:07^|ADT^10/26/06^|VOL^6.0^|NLMORPH^^|CONC^114.8^<etx>A1<cr><lf>
            send <ack>
            """,
            (
                "O|SN#^52^|SID^6^|FIC^5^|ATM^08:07^|ADT^10/26/06^|VOL^6.0^|NLMORPH^^|CONC^114.8^"
            ),
        )

    def test_recv_message_cq(self):
        self.assertRecvMessageEqual(
            """
            recv <stx>5O|FIC^8^|CTY^1^|LOT^1^|EXD^01/00^|TAR^1.0^|RAN^1.0^|CTSC^5.3^|RST^1^|COA^1^|CMSC^^<etx>D0<cr><lf>
            send <ack>
            """,
            (
                "O|FIC^8^|CTY^1^|LOT^1^|EXD^01/00^|TAR^1.0^|RAN^1.0^|CTSC^5.3^|RST^1^|COA^1^|CMSC^^"
            ),
        )
