# -*- coding: utf8 -*-

from __future__ import unicode_literals

from driverng.tests import BaseTest


class StarrsedTest(BaseTest):
    PROTOCOL_CLASS = "acknack"
    PROTOCOL_KWARGS = {"checksum_type": "xor_starrsed"}

    def test_send_recv(self):
        self.assertSendRecvMessageEqual(
            """
        ESRSR                       123456789                                                                                      R """,
            """
        send <stx>ESRSR                       123456789                                                                                      R &<etx>
        recv <ack>
        """,
        )

    def test_recv(self):
        self.assertRecvMessageEqual(
            """
            recv <stx>
            recv ESRRE                       1234567890123456                        11122003  0850    10   27                        0    1        84   60   24  100    0    0 B<etx>
            """,
            """ESRRE                       1234567890123456                        11122003  0850    10   27                        0    1        84   60   24  100    0    0 """,
        )
