# -*- coding: utf8 -*-
from __future__ import unicode_literals

from driverng.astm import HprimString, Segment


def test_end_line_with_separator():
    class XSegment(Segment):
        k = HprimString(4)

    class YSegment(XSegment):
        END_LINE_WITH_SEPARATOR = True

    assert XSegment(k="v").to_string() == "|||v"
    assert YSegment(k="v").to_string() == "|||v|"


def test_fill_segment():
    class XSegment(Segment):
        FILL_SEGMENT = 10
        k = HprimString(4)

    class YSegment(XSegment):
        FILL_SEGMENT = 3

    class ZSegment(YSegment):
        END_LINE_WITH_SEPARATOR = True

    assert XSegment(k="v").to_string() == "|||v||||||"
    assert YSegment(k="v").to_string() == "|||v"
    assert ZSegment(k="v").to_string() == "|||v|"
